#:kivy 1.10.0
#:import Config kivy.config.Config
#:import Window kivy.core.window.Window
#:import randfloat random.uniform
#:import DnD kivydnd.dndwidgets.DragNDropWidget

<SettingColorPicker>:
    Label:
        text: root.value or '#000000FF'
        color: app.guash_root._background_color or (1, 1, 1, 1)

<SelectableLabel>:
    # Draw a background to indicate selection
    canvas.before:
        Color:
            rgba: app.guash_root._selected_color if self.selected else app.guash_root._background_color
        Rectangle:
            pos: self.pos
            size: self.size

<SelectView>:
    viewclass: 'SelectableLabel'
    SelectableRecycleBoxLayout:
        id: selected
        default_size: None, dp(56)
        default_size_hint: 1, None
        size_hint_y: None
        height: self.minimum_height
        orientation: 'vertical'
        multiselect: False
        touch_multiselect: False


<TimelineLabel@Label>:
    size_hint_x: None
    canvas.before:
        Color:
            rgba: (randfloat(0.0, 1.0), randfloat(0.0, 1.0), randfloat(0.0, 1.0), 1)
        Rectangle:
            pos: self.pos
            size: self.size

<Guash>
    BoxLayout:
        orientation: 'vertical'
        Label:
            id: timeline_title
            size_hint_y: 0.05
            text: 'Timeline'
        ScrollView:
            width: Window.width
            size_hint: (None, 0.4)
            BoxLayout:
                id: timeline_layout
                size_hint_x: None
        ActionBar:
            id: playbar
            ActionView:
                ActionPrevious:
                    app_icon: ''
                    with_previous: False
                ActionButton:
                    text: 'Button1'
                ActionButton:
                    text: 'Button2'
        BoxLayout:
            size_hint_y: 0.6
            BoxLayout:
                size_hint_x: 0.03
                orientation: 'vertical'
                Button:
                    text: 'Connect'
                    on_release: root.connect()
                CheckBox:
                    id: wireframe
                    on_active: root.toggle_wireframe(self, self.active)
                CheckBox:
                    id: loose_clock
                    on_active: root.toggle_looseclock(self, self.active)
                Button:
                    id: request_render
                    text: 'Render Image'
                    on_release: root.request_current_render()
                Button:
                    text: 'Settings'
                    on_release: app.open_settings()
            BoxLayout:
                size_hint_x: 0.4
                orientation: 'vertical'
                SelectView:
                    id: media_files
                    canvas.before:
                        Color:
                            rgba: root._background_color
                        Rectangle:
                            pos: self.pos
                            size: self.size
                    select_method: root.request_media_info
                    data: root._media
                Button:
                    size_hint_y: 0.1
                    text: 'Add to timeline'
                    on_release: root.add_to_timeline(media_files.ids.selected.index)
                Button:
                    size_hint_y: 0.1
                    text: 'Activate selected medium'
                    on_release: root.activate_media(media_files.ids.selected.index)
                Button:
                    size_hint_y: 0.1
                    text: 'Preview medium'
                    on_release: root.request_preview_media(media_files.ids.selected.index)
                Button:
                    size_hint_y: 0.1
                    text: 'Get media files'
                    on_release: root.request_media_files()
            Widget:
                id: preview
                size_hint_x: 0.3
                id: render_image
                canvas:
                    Rectangle:
                        pos: self.pos
                        size: self.size
                        texture: root._sink_texture
            BoxLayout:
                orientation: 'vertical'
                size_hint_x: 0.2
                Label:
                    id: width
                    size_hint_y: 0.05
                    text: "Width: " + str(root._media_width)
                Label:
                    id: height
                    size_hint_y: 0.05
                    text: "Height: " + str(root._media_height)
                Label:
                    id: bpp
                    size_hint_y: 0.05
                    text: "BPP: " + str(root._media_bpp)
                Label:
                    id: channels
                    size_hint_y: 0.05
                    text: "Channels: " + str(root._media_channels)
                Label:
                    id: format
                    size_hint_y: 0.05
                    text: "Format: " + root._media_format
                Label:
                    id: duration
                    size_hint_y: 0.05
                    text: "Duration: " + str(root._media_duration)
                BoxLayout:
                    size_hint_y: 0.7
        RelativeLayout:
            size_hint_y: 0.02
            TaskBarLabel:
                pos_hint: {'x': 0.35}
                text: 'FPS: ' + root._fps
            TaskBarLabel:
                pos_hint: {'x': 0.4}
                text: 'Master clock: ' + root._clock

<TaskBarLabel@Label>:
    font_size: 12
